'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

exports.default = WebDriver;

var _wdioLogger = require('wdio-logger');

var _wdioLogger2 = _interopRequireDefault(_wdioLogger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function WebDriver(sessionId, options, modifier) {
    var prototype = (0, _create2.default)(Object.prototype);
    var log = (0, _wdioLogger2.default)('webdriver');

    /**
     * WebDriver monad
     */
    function unit() {
        var client = (0, _create2.default)(prototype);
        client.options = options;
        client.sessionId = sessionId;

        if (typeof modifier === 'function') {
            client = modifier(client, options);
        }

        return client;
    }

    unit.lift = function (name, func) {
        prototype[name] = function () {
            var client = unit();

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            log.info('COMMAND', `${name}(${args.join(', ')})`);
            return func.apply(client, args);
        };
    };

    return unit;
}
module.exports = exports['default'];